<!DOCTYPE html>
<html>
<head>

	<title>Bootstrap Grid System</title>
	 <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">

</head>
<body>
	<h1 class="text text-white bg-primary">Bootstrap Grid System</h1>

	<div class="container-fluid">
		<!-- a div column can occupy more than 1 column, we may create layouts where in one div occuoies 8 columns and another one occupies 4 columns
		-12 columns 1 row 
		syntax to define the number of colunmn a div will occupy in a rowL col-breakpoint-numberofcolumns(must not exceed 12 to aoid overflow-->

		<div class="row">
			<!-- div 1 -->
			<div class="bg-success border border-dark col-md-8">
				Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
				tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
				quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
				consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
				cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
				proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
			</div>

			<!-- div 2 -->
			<div class="bg-warning border border-dark col-md-8">
				Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
				tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
				quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
				consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
				cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
				proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
			</div>
		</div>

		<!-- end div -->
		<h2 class="text-center">Rows with 2 equal columns</h2>
		<h3 class="text-center">1:1 Ratio</h3>

		<div class="row mt=3">
			<div class="bg-primary py-3 border border-dark col-6">
				<h2 class="text-center">6 Columns</h2>
				<p>
					Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
					tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
					quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
					consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
					cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
					proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
				</p>
			</div>
			<div class="bg-danger py-3 border border-dark col-6">
				6 column
			</div>
		</div>
        <!-- end row 1:1 -->
        <h3 class="text-center"> 1:2 Ratio</h3>
        <div class="row">
        	<div class="bg-success py-3 border border-dark col-4">4 col</div>
        	<div class="bg-info py-3 border border-dark col-8">8 col</div>
        </div>


       <!-- mini activity -->
       <h3 class="text-center">1:3 Ratio</h3>
       <div class="row">
       	<div class="bg-danger py-3 border border-dark col-3">3 col</div>
       	<div class="bg-warning py-3 border border-dark col-9">9 col</div>
       </div>
	</div>

	<!-- mini activity:
	create a row with column in 1:3 ratio, meaning 1 of the column is thrice as big as the other one

	bg-color: warning bigger column
	bg color: danger smaller column
	add dark dark border per column
	output should be post in hangouts batch 145 -->

<h3 class="text-center">1:2:1 Ratio</h3>
<div class="row">
	<div class="bg-warning py3 border border-dark col-3">3 col</div>
	<div class="bg-success py3 border border-dark col-6">6 col</div>
	<div class="bg-warning py3 border border-dark col-3">3 col</div>
</div>
 
<h2 class="text-center">Auto Columns</h2>
<!-- are columns which adjust themseves according to the number let in a row -->
<div class="row">
	<div class="bg-success py-5 border border-dark col">Auto 1</div>
	<div class="bg-success py-5 border border-dark col">Auto 2</div>
	<div class="bg-primary py-5 border border-dark col-8">Col-8</div>
	<div class="bg-success py-5 border border-dark col">Auto 4</div>
	<div class="bg-success py-5 border border-dark col">Auto 5</div>
</div>
<!-- end of auto column div -->

<h3 class="text-center">Rows with uneven column</h3>
<div class="row">
	<div class="bg-info py-5 border border-dark col-7">col-7</div>
	<div class="bg-info py-5 border border-dark col-5">col-5</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
	<div class="bg-info py-5 border border-dark col-4">col-4</div>
</div>
<!-- end of uneven columns -->

<h2 class="text-center">Responsive columns</h2>
<!-- breakpoints

you can set the number of columns a div occupies per screen using breakpoint however, by default, from the smallest screen a div especially with class col will occupy 12 columns. 

breakpoints are the screen or point the number of columns considered changes based on screen size, so fom the smallest screen,  adiv may occupy the whle row but in a large screen it only occupies 6 columns.


since Boostrap was designed with mobile first approach in mind, the defaut breakpoint is for the smallest screen.

Meaning untik you add a breakpoint (smm-md-lgg-xl) the number of columns a div will occupy will be the same from the smallest to largest screen

col-6 (div is 6 columns from the smallest screen up to the largest)
col-md-5 (div 6 columns only from medium to largest

default and sm are screens about the size of smartphones
md- screen sizes about the size of a regular ipad
lg-screen sizes about the size of a desktop/laptop screen
xl - screen size about the size of a larger desktop/laptop screen-->

<div class="row">
	<div class="bg-secondary py-3 border border-dark col-md-4">
		4 cols md to lg
	</div>
	<div class="bg-primary py-3 border border-dark col-md-6">
		6 cols md to lg
	</div>
	<div class="bg-danger py-3 border border-dark col-md-2">
		2 cols md to lg
	</div>
</div>
<!-- end of div -->

<div class="row">
	<div class="bg-dark border border-white col-4">
		col-4 from sm to lg
	</div>
	<div class="bg-primary border border-dark col-8 col-md-6"> 8 cols 6c coll from md to lg</div>
</div>
<!-- end of div -->
 

 <h3 class="text-center">activity</h3>
 <div class="row">
 	<div class="bg-primary border border-dark col-6">6 columns to lg</div>
 	<div class="bg-danger border border-dark col-6 col-md-10">6 col sm 10 md to lg</div>
 </div>
<div>
	<div class="bg-success border border-black col-12 col-md-8"> 12 col sm8 md to lg</div>
	<div class="bg-info border border-dark col-6 col-md-2">6 sm 2md to lg</div>
	<div class="bg-success border border-dark col-6 col-md-2">6 sm 2 md lg</div>
</div>


    <!-- Script -->
<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.min.js" integrity="sha384-VHvPCCyXqtD5DqJeNxl2dtTyhF78xXNXdkwX1CZeRusQfRKp+tA7hAShOK/B/fQ2" crossorigin="anonymous"></script>

</body>
</html>